﻿using Data;
using DomainClasses;
using Microsoft.EntityFrameworkCore;
using SharedKernel;
using System;
using System.Linq;

namespace EFCore5Console
{
    internal class Program
    {
        private static PeopleContext _context;

        private static void Main(string[] args)
        {
            Globals.CurrentUserId = 101;

            var pid = System.Diagnostics.Process.GetCurrentProcess().Id;

            using (var context = new PeopleContext())
            {
                context.Database.EnsureDeleted();
                context.Database.EnsureCreated();
            }

            _context = new PeopleContext();
            Console.Clear();
            InsertPerson();
            InsertPersonWithAddress();
            GetAllPeople();
        }

        private static void InsertPerson()
        {
            _context.People.Add(new Person { FirstName = "Julie", LastName = "Lerman" });
            _context.SaveChanges();
        }

        private static void GetAllPeople()
        {
            _context.ChangeTracker.Clear();
            var query = _context
                .People.Where(p => p.FirstName == "Julie");
            var people = query.ToList();

            var person = people.First();
            person.LastName = "Lermantov";
            _context.ChangeTracker.DetectChanges();
        }

        private static void InsertPersonWithAddress()
        {
            var person = new Person { FirstName = "Julie", LastName = "Lerman" };
            person.Addresses.Add(new Address { Street = "One Main" });
            _context.People.Add(person);
            _context.SaveChanges();
        }
    }
}