using Microsoft.EntityFrameworkCore;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Data;
using DomainClasses;
using System;

namespace Tests
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void SQLDoesNotContainSelectStar()
        {
            var builder = new DbContextOptionsBuilder();
            builder.UseSqlite("Data Source = testdb.db");
            using var context = new PeopleContext(builder.Options);
            var sql = context.People.ToQueryString();
            Console.WriteLine(sql);
            Assert.IsFalse(sql.ToUpper().Contains("SELECT *"));

        }

        [TestMethod]
        public void DeletedPersonIsFilteredOutOfQueries()
        {
            var builder = new DbContextOptionsBuilder();
            builder.UseSqlite("Data Source = testdb.db");
            using var context = new PeopleContext(builder.Options);
            var sql = context.People.ToQueryString();
            Console.WriteLine(sql);
            Assert.IsTrue(sql.ToUpper().Contains("WHERE NOT (\"p\".\"IsDeleted\")"));

        }
    }
}
